<template>
  <SwPluginSlot name="gs-navigation-back-button">
    <template v-if="isGuide || isSelfService">
      <SwButton v-if="showProductPage"
                class="sw-gs-navigation-back-btn color-transparent is-circle"
                :title="$t('Back to presentation')"
                @click="closeDynamicPage({
                    type: 'product',
                    opened: false,
                    productId: productId
                  })">
        <SwGsIconLongArrowLeft class="color-dark-secondary size-sm"/>
      </SwButton>
      <SwButton v-else-if="showLikeListPage"
                class="sw-gs-navigation-back-btn color-transparent is-circle"
                :title="$t('Back to presentation')"
                @click="closeDynamicPage({
                        type: 'likeList',
                        opened: false
                      })">
        <SwGsIconLongArrowLeft class="color-dark-secondary size-sm"/>
      </SwButton>
    </template>
  </SwPluginSlot>
</template>

<script lang="ts">
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue";
  import SwButton from "@/components/atoms/SwButton.vue";
  import { SwGsIconLongArrowLeft } from "../icons";
  import { useAppointment } from "../../logic/composables/useAppointment";
  import { usePresentation } from "../../logic/composables/usePresentation";
  import { useDynamicPage } from "../../logic/composables/useDynamicPage";
  import { useLikeList } from "../../logic/composables/useLikeList";
  import { computed } from "@vue/composition-api";

  export default {
    name: 'SwGsBackButton',
    components: {
      SwPluginSlot,
      SwButton,
      SwGsIconLongArrowLeft
    },
    setup() {
      const { isGuide, isSelfService } = useAppointment();
      const { showProductPage } = usePresentation();
      const { closeDynamicPage, dynamicPage } = useDynamicPage();
      const { showLikeListPage } = useLikeList();

      return {
        isGuide,
        isSelfService,
        showProductPage,
        closeDynamicPage,
        showLikeListPage,
        productId: computed(() => dynamicPage?.value?.type === 'product' ? dynamicPage?.value?.productId : null)
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-navigation-back-btn {
    margin-right: var(--spacer-xs);
  }
</style>
